class DCoop expands CoopGame
	config(DCoop);

#exec obj load FILE=..\Textures\DCoopTextures.utx PACKAGE=DCoopTextures
#exec obj load FILE=..\Sounds\DCoopSounds.uax PACKAGE=DCoopSounds

struct DBan
{
var() config bool bRealBan;
var() config bool bEnabled;
var() config bool bIPBan;
var() config string BanIP;
var() config bool bIDBan;
var() config string BanID;
var() config bool bTemp;
var() config int  LeftMC;
};

struct ClassOverride
{
var() config class<PlayerPawn> DesiredClass;
var() config class<PlayerPawn> ReplaceWith;
};

struct MapCtrl
{
var() config string TheMap;
var() config string NextMap;
var() config bool bOvrNextMap;
var() config float TimeLimit;
var() config bool bOvrTimeLimit;
};

var(FriendlyFire) config float FFDamageMultiplier;
var(FriendlyFire) config float FFMomentumMultiplier;
var(FriendlyFire) config bool FFReport;

var(GameControl) config float InventoryRespawnTime;
var(GameControl) config bool bKeepInventory;
var(GameControl) config bool bAllowSprees;
var(GameControl) config bool bUseSpreeSounds;
var(GameControl) config bool bAllowMultikills;
var(GameControl) config float MultiKillDelay;
var(GameControl) config bool bUseMultikillSounds;
var(GameControl) config float TimeLimit;
var(GameControl) config bool bUseCountdownSounds;
var(GameControl) config bool bUseCoolURLs;
var(GameControl) config bool bMonstersDropAllInv;
var(GameControl) config MapCtrl MapControl[128];
var(GameControl) config bool bShowEnds;
var(GameControl) config bool bShowAllDeaths;
var(GameControl) config bool bKaosDmStyle; //Credit to KoopGame2 for THIS
var(GameControl) config float LowKillZ;
var(GameControl) config float HiKillZ;
var(GameControl) config bool bAllowModMyPw;

var(HUD) config float MOTDFadeOut;
var(HUD) config float MsgLife;
var(HUD) config bool SSMFade;
var(HUD) config color EnteredColor;
var(HUD) config color LeftColor;
var(HUD) config color ServerColor;
var(HUD) config bool bUseStaticTex;
var(HUD) config bool bUseStaticDF;

var(Messages) config string ConnectMsg;
var(Messages) config string EnterMsg;
var(Messages) config string RenameMsg;
var(Messages) config string LeaveMsg;
var(Messages) config string KickMsg;

var(Handlers) config string AHandlerClass;
var(Handlers) config string CGHandlerClass;
var(Handlers) config string NHandlerClass;
var(Handlers) config string RHandlerClass;
var(Handlers) config string SHandlerClass;
var(Handlers) config string THandlerClass;
var(Handlers) config string UHandlerClass;

var(Scoring) config int FFKillPenalty;
var(Scoring) config int SuicidePenalty;

var(PlayerControl) config bool bUseHardcodedClassOverrides;
var(PlayerControl) config ClassOverride ClassOverrides[64];
var(PlayerControl) config DBan Banned[255];
var(PlayerControl) config int MinSeeLvl;
var(PlayerControl) config int MinSeeUser;
var(PlayerControl) config int MinSeeAdminMsgs;
var(PlayerControl) config string DefaultWeaponClass;
var(PlayerControl) config string GiveItems[128];
var(PlayerControl) config int NumMultiJumps;
var(PlayerControl) config bool bAllowDuckjumps;
var(PlayerControl) config string MusicOverrides[128];
var(PlayerControl) config string CSWhenJoined;
/* MusicOverride format: SongName\SongSect=>NewSong\NewSect */

var(Security) config bool bRejectUntrustedConsoles;
var(Security) config bool bRejectUntrustedPackages;
var(Security) config bool bTrustConsoleIfCanLoadClass;
var(Security) config bool bTrustStandartUPkgs;
var(Security) config int MinUntrustedPackagesForKick;
var(Security) config string TrustedConsoles[256];
var(Security) config string TrustedPackages[256];

var(VotingControl) config bool bAllowVoteCancel;
var(VotingControl) config float VoteCancelPct;
var(VotingControl) config bool bAllowVoteEnd;
var(VotingControl) config float VoteEndPct;
var(VotingControl) config bool bAllowVoteKick;
var(VotingControl) config float VoteKickPct;
var(VotingControl) config bool bAllowVoteMap;
var(VotingControl) config string VoteMaps[128];
var(VotingControl) config float VoteMapPct;
var(VotingControl) config bool bAllowVoteSkip;
var(VotingControl) config float VoteSkipPct;

/* Handlers */
var DAHandler AHandler;    //Authority handler
var DCGHandler CGHandler;  //ComeGo handler
var DKHandler KHandler;    //KAOS DM handler
var DNHandler NHandler;    //Network handler
var DRHandler RHandler;    //Replacement handler
var DSHandler SHandler;    //InvShop handler
var DTHandler THandler;    //DataTable handler
var DUHandler UHandler;    //Userinfo handler

var string GBans[255];
var DPri DCPri;
var string Players[64];

var playerpawn EndingGuy;
var string EndingURL;

var int CDT;
var pawn IterPawn;
var teleporter IterTele;

var class<Inventory> GiveItem[128];

var bool bDontFire;
var bool bDontEnd;

var string CLev;
var bool bForceNextMap;
var string NextMap;
var float TimeCountdown;
var bool bParseTHIS;

var teleporter EndTele;

event InitGame( string Options, out string Error )
{
	local string InOpt, LeftOpt;
	local int pos;
	local class<Mutator> MClass;
	local mover M;

	Log("Initializing...",'DCoop');
	Log("Version "$Class'DUtil'.Static.Ver(),'DCoop');

	foreach AllActors(Class'Mover',M)
	{
		if( M != None )
		{
			if ( (M.MoverEncroachType == ME_ReturnWhenEncroach) ||
			     (M.MoverEncroachType == ME_StopWhenEncroach) )
			    M.MoverEncroachType = ME_IgnoreWhenEncroach;
			/* Less realism = less problems !! */

			if ( M.MoverEncroachType == ME_CrushWhenEncroach )
				M.EncroachDamage = 2147483647;

			M.MoverEncroachType = ME_IgnoreWhenEncroach;

			if ( M.InitialState == 'TriggerControl' )
				M.InitialState = 'TriggerOpenTimed';

			if ( (M.IsInState('TriggerControl')) || (M.GetStateName() == 'TriggerControl') )
				M.GoToState('TriggerOpenTimed');

		}

	}

	log( Options, 'InitGame' );
	MaxPlayers = GetIntOption( Options, "MaxPlayers", MaxPlayers );
	InOpt = ParseOption( Options, "Difficulty" );
	if( InOpt != "" )
		Difficulty = int(InOpt);
	log( "Difficulty" @ Difficulty, 'InitGame' );

	InOpt = ParseOption( Options, "GameSpeed");
	if( InOpt != "" )
	{
		log("GameSpeed"@InOpt,'InitGame');
		SetGameSpeed(float(InOpt));
	}

	BaseMutator = spawn(MutatorClass);
	log("Base Mutator is "$BaseMutator,'InitGame');
	InOpt = ParseOption( Options, "Mutator");
	if ( InOpt != "" )
	{
		log("Mutators"@InOpt,'InitGame');
		while ( InOpt != "" )
		{
			pos = InStr(InOpt,",");
			if ( pos > 0 )
			{
				LeftOpt = Left(InOpt, pos);
				InOpt = Right(InOpt, Len(InOpt) - pos - 1);
			}
			else
			{
				LeftOpt = InOpt;
				InOpt = "";
			}
			log("Add mutator "$LeftOpt,'InitGame');
			MClass = class<Mutator>(DynamicLoadObject(LeftOpt, class'Class'));
			BaseMutator.AddMutator(Spawn(MClass));
		}
	}

	InOpt = ParseOption( Options, "GamePassword");
	if( InOpt != "" )
	{
//		GamePassWord = InOpt;
		ConsoleCommand("Set GameInfo GamePassword "$InOpt);
		log( "GamePassword" @ InOpt, 'InitGame' );
	}

	log("Initializing handlers...", 'InitGame');
	AHandler=DAHandler(CreateHandler(AHandlerClass));
	Assert(AHandler!=None);  Log("AHandler = "$AHandler, 'InitGame');
	CGHandler=DCGHandler(CreateHandler(CGHandlerClass));
	Assert(CGHandler!=None); Log("CGHandler = "$CGHandler, 'InitGame');
	KHandler=DKHandler(CreateHandler("DKHandler"));
	Assert(KHandler!=None); Log("KHandler = "$KHandler, 'InitGame');
	if (KHandler.NumDeathMessages==0)
		bParseTHIS=True;
	if ((NHandlerClass=="")||(NHandlerClass~="Automatic"))
	{
	if (int(Left(Level.EngineVersion,3))>226)
		NHandlerClass="DNHandler227";
	else if (DynamicLoadObject("Nephthys.NephthysProxy",class'Class')!=None)
		NHandlerClass="DCoopNPT.DNPTHandler";
	else
		NHandlerClass="DNHandlerSocks";
	}
	NHandler=DNHandler(CreateHandler(NHandlerClass));
	NHandlerClass="Automatic";
	Assert(NHandler!=None);  Log("NHandler = "$NHandler, 'InitGame');
	RHandler=DRHandler(CreateHandler(RHandlerClass));
	Assert(RHandler!=None);  Log("RHandler = "$RHandler, 'InitGame');
	SHandler=DSHandler(CreateHandler(SHandlerClass));
	Assert(SHandler!=None);  Log("SHandler = "$SHandler, 'InitGame');
	THandler=DTHandler(CreateHandler(THandlerClass));
	Assert(THandler!=None);  Log("THandler = "$THandler, 'InitGame');
	UHandler=DUHandler(CreateHandler(UHandlerClass));
	Assert(UHandler!=None);  Log("UHandler = "$UHandler, 'InitGame');

	InOpt = ParseOption( Options, "LocalLog");
	if( InOpt ~= "true" )
		bLocalLog = True;

	InOpt = ParseOption( Options, "WorldLog");
	if( InOpt ~= "true" )
		bWorldLog = True;
}

function DHandler CreateHandler(string HandlerClass)
{
	local class<DHandler> NewClass;
	if( instr(HandlerClass,".")==-1 )
		HandlerClass = Left(String(Class),InStr(String(Class),".")) $ "." $ HandlerClass;
	NewClass = class<DHandler>( DynamicLoadObject( HandlerClass, class'Class' ) );
	if (NewClass==None)
		return none;
	return Spawn(NewClass,Self);
}

function BrMsg(coerce string Msg, optional name Type, optional bool bBeep, optional PlayerReplicationInfo SenderPRI)
{
	local Pawn P;

	if (SenderPri==None)
		SenderPri=DCPri;

	if (Type == '')
		Type = 'Event';

	for( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		if( P.IsA('DPlayer') )
			DPlayer(P).RecvMsg( SenderPRI, Msg, Type, bBeep );
		else if ( P.bIsPlayer )
			P.ClientMessage(Msg,Type,bBeep);
	}
}

function BrXMsg(coerce string Msg, object O1, object O2, object O3, int Sw, class<DXMessage> MsgClass)
{
	local Pawn P;

	if (MsgClass==None)
		return;

	for (P=Level.PawnList;P!=None;P=P.NextPawn)
		if (P.IsA('DPlayer'))
			DPlayer(P).RecvXMsg(Msg,O1,O2,O3,Sw,MsgClass);
}

function GlobSound(sound Snd, optional float AdditiveMultiplier)
{
	local pawn P;
	for (P=Level.PawnList;P!=None;P=P.NextPawn)
		if (P.IsA('DPlayer'))
		if (AdditiveMultiplier==0)
			DPlayer(P).ReliableSound(Snd);
		else
			DPlayer(P).ReliableLoudSound(Snd,1+AdditiveMultiplier);
}

function RegisterPlayer(string IP)
{
	local int I;
	for (I=0;I<64;I++)
		if (Players[I]=="")
			{ Players[I]=IP; Log("Player <"$IP$"> registered at "$I,'DCoop'); return; }
}

function UnRegisterPlayer(string IP)
{
	local int I;
	for (I=0;I<64;I++)
		if (Players[I]==IP)
			{ Players[I]=""; Log("Player <"$IP$"> unregistered from "$I,'DCoop'); return; }
}

// Internal function used for MaskedCompare
static final function bool _match(out string mask, out string target)
{
  local string m, mp, cp;
  m = Left(mask, 1);
  while ((target != "") && (m != "*"))
  {
    if ((m != Left(target, 1)) && (m != "?")) return false;
    mask = Mid(Mask, 1);
    target = Mid(target, 1);
        m = Left(mask, 1);
  }

  while (target != "")
  {
        if (m == "*")
    {
      mask = Mid(Mask, 1);
            if (mask == "") return true; // only "*" mask -> always true
            mp = mask;
            cp = Mid(target, 1);
      m = Left(mask, 1);
        }
    else if ((m == Left(target, 1)) || (m == "?"))
    {
            mask = Mid(Mask, 1);
      target = Mid(target, 1);
        m = Left(mask, 1);
        }
    else
    {
            mask = mp;
      m = Left(mask, 1);
            target = cp;
      cp = Mid(cp, 1);
        }
    }

  while (Left(mask, 1) == "*")
  {
        mask = Mid(Mask, 1);
    }
    return (mask == "");
}

// Compare a string with a mask
// Wildcards: * = X chars; ? = 1 char
// Wildcards can appear anywhere in the mask
static final function bool MaskedCompare(coerce string target, string mask, optional bool casesensitive)
{
  if (!casesensitive)
  {
    mask = Caps(mask);
    target = Caps(target);
  }
  if (mask == "*") return true;

  return _match(mask, target);
}

function SpawnDCPri()
{
	DCPri=Spawn(class'DPRI',Self);
	DCPri.PlayerName="DCoop";
	DCPri.UserName="DCoop";
	DCPri.PlayerId=0;
	DCPri.Team=255;
	DCPri.UserLvl=5;
	DCPri.UserName="DCoop";
	DCPri.SimPing=1337;
	DCPri.ConName="Server";
	DCPri.SongName="None";
	DCPri.SongSect=255;
	DCPri.bSpec=True;
}

event PostBeginPlay()
{
	local teleporter T;
	local int I;
//	local actor A;
	local string S;
	/*S=ConsoleCommand("Get System Suppress");
	if (int(Left(Level.EngineVersion,3))>226)
	{ if (InStr(S,"'Warning'")==-1)
	{
	S=Left(S,Len(S)-1)$",'Warning')";
	ConsoleCommand("Set System Suppress "$S);
	} }
	else
	if ((InStr(S,",Warning,")==-1)&&(InStr(S,"(Warning,")==-1)&&(InStr(S,",Warning)")==-1))
	{
	S=Left(S,Len(S)-1)$",Warning)";
	ConsoleCommand("Set System Suppress "$S);
	}*/
	super.PostBeginPlay();
	NHandler.InitNetwork();
	SpawnDCPri();
	SetTimer(5,True);
	TimeCountdown=TimeLimit*60;
	CLev=Left(string(Level),InStr(string(Level),"."));
	if (CLev~="QueenEnd")
		bSpecialFallDamage=True;
	Log("Entering level "$CLev,'PostBeginPlay');
	foreach AllActors(class'Teleporter',T)
	if ((InStr(T.URL,"#")>=0)||(InStr(T.URL,"/")>=0))
	{ if (bShowEnds) Spawn(class'TeleMarker',Self,'',T.Location); NextMap=T.URL; EndTele=T; }
	for (I=0;I<128;I++)
		if (MapControl[I].TheMap!="")
		if (Caps(MapControl[I].TheMap)==Caps(CLev))
		{
		if (MapControl[I].bOvrTimeLimit)
			TimeCountdown=MapControl[I].TimeLimit;
		if (MapControl[I].bOvrNextMap)
			{
			NextMap=MapControl[I].NextMap;
			bForceNextMap=True;
			}
		break;
		}
/*	foreach AllActors(class'Actor',A)
	if (
		(String(Other)~="Passage.Trigger0")||
		(String(Other)~="SomehowBadName"
		)
	{
	A.SetCollision(False,False,False);
	A.Event='';
	A.Tag='';
	A.Destroy();
	}*/
}

event Timer()
{
	SaveConfig();
}

function HandleCountdown(float OldTime, float NewTime)
{
	if (OldTime>300 && NewTime<=300) HandlePassage(300);
	if (OldTime>240 && NewTime<=240) HandlePassage(240);
	if (OldTime>180 && NewTime<=180) HandlePassage(180);
	if (OldTime>120 && NewTime<=120) HandlePassage(120);
	if (OldTime>60  && NewTime<=60 ) HandlePassage(60);
	if (OldTime>30  && NewTime<=30 ) HandlePassage(60);
	if (OldTime>10  && NewTime<=10 ) HandlePassage(10);
	if (OldTime>9   && NewTime<=9  ) HandlePassage(9);
	if (OldTime>8   && NewTime<=8  ) HandlePassage(8);
	if (OldTime>7   && NewTime<=7  ) HandlePassage(7);
	if (OldTime>6   && NewTime<=6  ) HandlePassage(6);
	if (OldTime>5   && NewTime<=5  ) HandlePassage(5);
	if (OldTime>4   && NewTime<=4  ) HandlePassage(4);
	if (OldTime>3   && NewTime<=3  ) HandlePassage(3);
	if (OldTime>2   && NewTime<=2  ) HandlePassage(2);
	if (OldTime>1   && NewTime<=1  ) HandlePassage(1);
	if (OldTime>0   && NewTime<=0  ) HandlePassage(0);
	if (OldTime>-2  && NewTime<=-2 ) HandlePassage(-2);
}

function HandlePassage(int PassId)
{
	Log("HandleCountdown: "$PassId,'DCTimer');
	GlobCDSound(PassId);
	if (PassId==300) BrMsg("5 minutes remaining",'CriticalEvent',False);
	if (PassId==240) BrMsg("4 minutes remaining",'CriticalEvent',False);
	if (PassId==180) BrMsg("3 minutes remaining",'CriticalEvent',False);
	if (PassId==120) BrMsg("2 minutes remaining",'CriticalEvent',False);
	if (PassId==60) BrMsg("1 minute remaining",'CriticalEvent',False);
	if (PassId==30) BrMsg("30 seconds left!",'CriticalEvent',False);
	if (PassId==10) BrMsg("10 seconds left!",'CriticalEvent',False);
	if (PassId==9) BrMsg("9 seconds left!",'CriticalEvent',False);
	if (PassId==8) BrMsg("8 seconds left!",'CriticalEvent',False);
	if (PassId==7) BrMsg("7 seconds left!",'CriticalEvent',False);
	if (PassId==6) BrMsg("6 seconds left!",'CriticalEvent',False);
	if (PassId==5) BrMsg("5 seconds left!",'CriticalEvent',False);
	if (PassId==4) BrMsg("4 seconds left!",'CriticalEvent',False);
	if (PassId==3) BrMsg("3 seconds left!",'CriticalEvent',False);
	if (PassId==2) BrMsg("2 seconds left!",'CriticalEvent',False);
	if (PassId==1) BrMsg("1 seconds left!",'CriticalEvent',False);
	if (PassId==0) BrMsg("Time up!",'EndCountdownIM',True);
	if (PassId==-2) GotoState('Ending');
}

event Tick(float Delta)
{
	local pawn P;
	super.Tick(Delta);
	if (DCPri==None)
	SpawnDCPri();
	if (TimeLimit>0)
	{
		TimeCountdown-=Delta;
		Handlecountdown(TimeCountdown+Delta,TimeCountdown);
	}
	for (P=Level.PawnList;P!=None;P=P.nextPawn)
	if (P.IsA('ScriptedPawn'))
	if (!P.IsInState('Waiting'))
	if (P.Enemy==None)
	if (!P.IsInState('StartUp'))
	P.GotoState('Waiting');
}

/* ================== Utilities block begin ================== */

/* Return the class that game should spawn for player */
function class<PlayerPawn> GetClassOverride(class<PlayerPawn> DesiredClass)
{
	local class<PlayerPawn> Res;

	/* Check if not empty */
	if (DesiredClass==None)
	DesiredClass=DefaultPlayerClass;

	Res=_GetClassOverride(DesiredClass);

	if (!ClassIsChildOf(Res,class'DPlayer'))
	return class'DMaleThree';

	return Res;
}

/* Internal function used by GetClassOverride */
function class<PlayerPawn> _GetClassOverride(class<PlayerPawn> DesiredClass)
{
	local string S;
	local int I;

	/* Handle hardcoded classes */
	if (bUseHardcodedClassOverrides)
	{
		/* Initialize string var for hardcoded checking */
		S=String(DesiredClass);
		if (InStr(S,".")==-1) S="UnrealI."$S;
		S=Mid(S,InStr(S,".")+1);

        /* Do check on every standart class */
        if (ClassIsChildOf(DesiredClass,class'Spectator'))
        	return class'DSpectator';
		if ((S~="FemaleOne")||(S~="UPakFemaleOne"))
			return class'DFemaleOne';
		if ((S~="FemaleTwo")||(S~="UPakFemaleTwo"))
			return class'DFemaleTwo';
		if ((S~="MaleOne")||(S~="UPakMaleOne"))
			return class'DMaleOne';
		if ((S~="MaleTwo")||(S~="UPakMaleTwo"))
			return class'DMaleTwo';
		if ((S~="MaleThree")||(S~="UPakMaleThree"))
			return class'DMaleThree';
		if (S~="NaliPlayer")
			return class'DNaliPlayer';
		if (S~="SkaarjPlayer")
			return class'DSkaarjPlayer';
	}

	/* Handle class overrides */
	for (I=0;I<64;I++)
	if (ClassOverrides[I].DesiredClass!=None)
	if (ClassOverrides[I].DesiredClass==DesiredClass)
	return ClassOverrides[I].ReplaceWith;

	return DesiredClass;
}

/* ================== Utilities block end ================== */

/* Init actors */
function bool IsRelevant(actor Other)
{
	local byte bSuperRelevant;
	// hide all playerpawns
	if (Other==None) return true; //?!

	if (String(Other)~="Passage.Trigger0") return false;
	if (String(Other)~="Noork.Trigger1") return false;
	if (String(Other)~="Noork.Trigger2") return false;
	if (String(Other)~="Ruins.Trigger1") return false;
	if (String(Other)~="VeloraEnd.Trigger6") return false;
	if (String(Other)~="NaliBoat.Trigger0") return false;
	if (String(Other)~="NaliC.Trigger12") return false;

	if ( Other.IsA('PlayerPawn') /*&& !Other.IsA('DSpectator')*/ )
	{
		Other.SetCollision(false,false,false);
		Other.bHidden = true;
	}

	// let the mutators mutate the actor or choose to remove it
	if ( BaseMutator != none )
	if ( BaseMutator.IsRelevant(Other, bSuperRelevant) )
	{
		if ( bSuperRelevant == 1 ) // mutator wants to override any logic in here
			return true;
	}
	else return false;

	if (!Other.IsA('PlayerPawn')) //Dont ever do this!!!!!!!!!!!!!!!!!!!!!!
	if (RHandler!=None) //This can be called for shit b4 handler spawned!
	if (RHandler.ReplaceActor(Other)) return false; //Replaced, dont spawn.

	if
	(	(Difficulty==0 && !Other.bDifficulty0 )
	||  (Difficulty==1 && !Other.bDifficulty1 )
	||  (Difficulty==2 && !Other.bDifficulty2 )
	||  (Difficulty==3 && !Other.bDifficulty3 )
	||  (!Other.bSinglePlayer && (Level.NetMode==NM_Standalone) )
	||  (!Other.bNet && ((Level.NetMode == NM_DedicatedServer) || (Level.NetMode == NM_ListenServer)) )
	||  (!Other.bNetSpecial  && (Level.NetMode==NM_Client)) )
		return False;

	if( bNoMonsters && (Other.IsA('Pawn')) && !Pawn(Other).bIsPlayer )
		return False;

	if( FRand() > Other.OddsOfAppearing )
		return False;

    // Update the level info goal counts.
    if( Other.bIsSecretGoal )
       SecretGoals++;

    if( Other.bIsItemGoal )
       ItemGoals++;

    if( Other.bIsKillGoal )
       KillGoals++;

	return True;
}

/* Handle Class and Password check, announce PreLogin, check for IP bans */
event PreLogin
(
	string Options,
	out string Error
)
{
	local string InPassword;
	local string InClass;
	local string InName;
	local string GPass;
	local int I;

	local string IPAddr;
	IPAddr=NHandler.GetIP(0);

	GPass=ConsoleCommand("Get GameInfo GamePassword");
	Error="";
	CGHandler.HandlePreLogin(Options,Error);
	if (Error!="") return;
	InName = ParseOption( Options, "Name" );
	InClass = ParseOption( Options, "Class" );
	InPassword = ParseOption( Options, "Password" );
	if ( InStr(InClass,"%")!=-1 )
	{
	 	Error="Dont even try to crash server running DCoop, dumbass!";
	 	Log("Alert: "$InName$" attempted to crash the server!!!",'DCoop');
	 	//BrXMsg(Level,InName$"|"$"Server crash attempt",None,None,None,0,class'DFailJoinMsg');
	 	BrMsg(InName$" failed PreLogin (Tried to crash server)",'FailJoinMessage',True);

	}
	else if( (Level.NetMode != NM_Standalone) && (MaxPlayers>0) && (NumPlayers>=MaxPlayers) )
	{
		Error="Server is already at capacity ("$NumPlayers$"\\"$MaxPlayers$")";
		Log(InName$" failed PreLogin because server is full.",'DCoop');
		//BrXMsg(Level,InName$"|"$"Server is full",None,None,None,0,class'DFailJoinMsg');
		BrMsg(InName$" failed PreLogin (Server is full)",'FailJoinMessage',True);

	}
	else if
	( GPass!="" && InPassword!=GPass )
	{
		if( InPassword == "" )
		{
			Error = "Password is required to enter this game";
            Log(InName$" failed PreLogin because of no password.",'DCoop');
            //BrXMsg(Level,InName$"|"$"No password supplied",None,None,None,0,class'DFailJoinMsg');
			BrMsg(InName$" failed PreLogin (No password supplied)",'FailJoinMessage',True);
		}
		else
		{
			Error = "You have entered wrong password, keep guessing";
			Log(InName$" failed PreLogin because of WRONG password.",'DCoop');
			//BrXMsg(Level,InName$"|"$"Invalid password supplied",None,None,None,0,class'DFailJoinMsg');
			BrMsg(InName$" failed PreLogin (Wrong password supplied)",'FailJoinMessage',True);
		}
	}
	if (Error=="")
	{
		/* Not rejected yet? Then we are coming to YOU! Ban check */
    	for (I=0;I<255;I++)
			if (Banned[I].bRealBan)
		    	if (Banned[I].bIPBan)
		    		if (MaskedCompare(IPAddr,Banned[I].BanIP,false))
		    		{
		    			if (Banned[I].bTemp)
		    				{
		    				Error="Your are temporarily banned ("$Banned[I].LeftMC$" MC) from this server!";
		    				Log(InName$" failed PreLogin because of a TBan ("$Banned[I].LeftMC$" MC).",'DCoop');
		    				//BrXMsg(Level,InName$"|"$"Temporary IP ban",None,None,None,0,class'DFailJoinMsg');
							BrMsg(InName$" failed PreLogin (Temporary ban)",'FailJoinMessage',True);
		    				}
		    			else
		    				{
		    				Error="You are permanently banned from this server!";
		    				Log(InName$" failed PreLogin because of a PBan.",'DCoop');
		    				//BrXMsg(Level,InName$"|"$"Permanent IP ban",None,None,None,0,class'DFailJoinMsg');
							BrMsg(InName$" failed PreLogin (Permanent ban)",'FailJoinMessage',True);
		    				}
		    		}
		/* Check for Global Bans */
		for (I=0;I<255;I++)
			if (GBans[I]!="")
				if (MaskedCompare(IPAddr,GBans[I],false))
					Error="!!!You are banned!!!";
	}
	if (Error=="")
	{
	/* Alrite, you passed PreLogin, congrats [Let everyone know about it] */
	//BrXMsg(Level,InName,None,None,None,-1,class'DJoinLeaveMsg');
	BrMsg(InName$" is connecting to this server...",'JoinMessage',True);
	}
}

function NavigationPoint FindPlayerStart( byte Team, optional string incomingName )
{
	local PlayerStart Dest, Candidate[8], Best;
	local float Score[8], BestScore, NextDist;
	local pawn OtherPlayer;
	local int i, num;
	local Teleporter Tel;

	num = 0;
	//choose candidates
	foreach AllActors( class 'PlayerStart', Dest )
	{
		if ( (Dest.bSinglePlayerStart || Dest.bCoopStart) /*&& !Dest.Region.Zone.bWaterZone*/ )
		if ( !Dest.IsA('DPlayerStart') )
		{
			if (num<4)
				Candidate[num] = Dest;
			else if (Rand(num) < 4)
				Candidate[Rand(4)] = Dest;
			num++;
		}
	}

	if (num>4) num = 4;
	else if (num == 0)
		return None;

	//assess candidates
	for (i=0;i<num;i++)
		Score[i] = 4000 * FRand(); //randomize

	foreach AllActors( class 'Pawn', OtherPlayer )
	{
		if (OtherPlayer.bIsPlayer)
		{
			for (i=0;i<num;i++)
			{
				NextDist = VSize(OtherPlayer.Location - Candidate[i].Location);
				Score[i] += NextDist;
				if (NextDist < OtherPlayer.CollisionRadius + OtherPlayer.CollisionHeight)
					Score[i] -= 1000000.0;
			}
		}
	}

	BestScore = Score[0];
	Best = Candidate[0];
	for (i=1;i<num;i++)
	{
		if (Score[i] > BestScore)
		{
			BestScore = Score[i];
			Best = Candidate[i];
		}
	}

	return Best;
}

function NavigationPoint DCFindPlayerStart( Pawn IncomingPlayer )
{
	local PlayerStart SCand[64],ISC;
	local float SScore[64];
	local DPlayerStart DCand[64],IDC;
	local float DScore[64];
	local DPlayerStart FCand[64],IFC;
	local float FScore[64];
	local DPlayer IterPawn;
	local int I,SC,DC,FC;
	local float BestScore;
	local int BS;
	for (I=0;I<64;I++)
	{ SCand[I]=None; SScore[I]=-123456789; DCand[I]=None; DScore[I]=-123456789; FCand[I]=None; FScore[I]=-123456789; }
	SC=0;
	foreach AllActors(class'PlayerStart',ISC)
	{
		if ( (ISC.bSinglePlayerStart || ISC.bCoopStart) )
		{
			SCand[SC]=ISC;
			if (IncomingPlayer!=None)
			SScore[SC]=4096*FRand()-VSize(IncomingPlayer.Location-ISC.Location);
			else
			SScore[SC]=4096*FRand();
			if (!ISC.bEnabled)
				SScore[SC]-=1000000;
			SC++;
		}
	}
	DC=0;
	foreach AllActors(class'DPlayerStart',IDC)
	{
		if ((IncomingPlayer==None)||(IDC.PlayerId==0))
		{
		DCand[DC]=IDC;
		if (IncomingPlayer!=None)
		DScore[DC]=4096*FRand()-VSize(IncomingPlayer.Location-IDC.Location);
		else
		DScore[DC]=4096*FRand();
		DC++;
		}
	}
	FC=0;
	if (IncomingPlayer!=None)
	foreach AllActors(class'DPlayerStart',IFC)
	{
		if ((IncomingPlayer==None)||(IFC.PlayerId==IncomingPlayer.PlayerReplicationInfo.PlayerID))
		{
		FCand[FC]=IFC;
		FScore[FC]=4096*FRand()-VSize(IncomingPlayer.Location-IFC.Location);
		FC++;
		}
	}
	if (FC>0)
	{
	/* USE AN ASSIGNED DPLAYERSTART! */
	BS=-1;
	BestScore=-123456789;
	for (I=0;I<FC;I++)
	if (FScore[I]>BestScore)
	{ BestScore=FScore[I]; BS=I; }
	if (BS!=-1)
	return FCand[BS];
	}
	if (DC>0)
	{
	/* USE A DPLAYERSTART! */
	BS=-1;
	BestScore=-123456789;
	for (I=0;I<DC;I++)
	if (DScore[I]>BestScore)
	{ BestScore=DScore[I]; BS=I; }
	if (BS!=-1)
	return DCand[BS];
	}
	if (SC>0)
	{
	/* Use a simple playerstart */
	BS=-1;
	BestScore=-123456789;
	for (I=0;I<SC;I++)
	if (SScore[I]>BestScore)
	{ BestScore=SScore[I]; BS=I; }
	if (BS!=-1)
	return SCand[BS];
	}
	return none;
}

/* Create player, do all the stuff, change class */
event playerpawn Login
(
	string Portal,
	string Options,
	out string Error,
	class<playerpawn> SpawnClass
)
{
	local PlayerPawn      NewPlayer, TestPlayer;
	local pawn			  aPawn;
	local NavigationPoint StartSpot;
	local Pawn            PawnLink;
	local string          InName, InPassword, InSkin, InFace;
	local byte            InTeam;
	local class<playerpawn> OldClass;
//	local inventory inv;

	local texture InTFace;
	local class<DFace> InDFace;
	local string IPAddr;
	IPAddr=NHandler.GetIP(1);
	if (InStr(IPAddr,":")>-1) IPAddr=Left(IPAddr,InStr(IPAddr,":"));

	// Make sure there is capacity. (This might have changed since the PreLogin call).
	if( (Level.NetMode != NM_Standalone) && (MaxPlayers>0) && (NumPlayers>=MaxPlayers) )
	{
		Error=MaxedOutMessage;
		return None;
	}

	OldClass=SpawnClass;
	SpawnClass=GetClassOverride(SpawnClass);

	// Get URL options.
	InName     = ParseOption( Options, "Name" ); /* Hehe */
	InTeam     = GetIntOption( Options, "Team", 255 );
	InPassword = ParseOption ( Options, "Password" );
	InSkin	   = ParseOption ( Options, "Skin"    );
	InFace     = ParseOption ( Options, "Face"    );
	Log(InName$" desired "$OldClass$" and got "$SpawnClass,'DCoop');
	log( "Login:" @ InName, 'DCoop' );
	if( InPassword != "" )
		log( "Password"@InPassword, 'DCoop' );

	// Find a start spot.
	StartSpot = DCFindPlayerStart( none );

	if( StartSpot == None )
	{
		Error = FailedPlaceMessage;
		return None;
	}

	// Try to match up to existing unoccupied player in level,
	// for savegames and coop level switching.
	for( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn )
	{
		TestPlayer = PlayerPawn(PawnLink);
		if
		( TestPlayer!=None && TestPlayer.Player==None )
		{
			if
			(	(Level.NetMode==NM_Standalone)	||	(TestPlayer.PlayerReplicationInfo.PlayerName~=InName) )
			{
				// Found matching unoccupied player, so use this one.
				NewPlayer = TestPlayer;
				break;
			}
		}
	}

	CGHandler.HandleLoginPre(Portal,Options,Error,SpawnClass,NewPlayer);
	if (Error!="")
	{
	if (Left(Error,7)=="Reject:")
	{
	Error=Mid(Error,7);
	return None;
	}
	Error="";
	}

	// if not found, spawn a new player.
	if( NewPlayer==None )
	{
		// Make sure this kind of player is allowed.
		if ( ClassIsChildOf(SpawnClass, class'Spectator') )
			SpawnClass=class'DSpectator';

		if ( (NumSpectators >= MaxSpectators) && (SpawnClass==class'DSpectator') )
		{
			Error="Max spectators exceeded";
			return None;
		}

		NewPlayer = Spawn(SpawnClass,,,StartSpot.Location,StartSpot.Rotation);
		if( NewPlayer!=None )
			NewPlayer.ViewRotation = StartSpot.Rotation;
	}

	// Handle spawn failure.
	if( NewPlayer == None )
	{
		log("Couldn't spawn player at "$StartSpot);
		Error = FailedSpawnMessage;
		return None;
	}
	CGHandler.HandleLoginPost(Portal,Options,SpawnClass,NewPlayer);

	DPlayer(NewPlayer).SSMFade=SSMFade;
	DPlayer(NewPlayer).MOTDFadeOut=MOTDFadeOut;
	DPlayer(NewPlayer).MsgLife=MsgLife;
	DPlayer(NewPlayer).EnteredColor=EnteredColor;
	DPlayer(NewPlayer).LeftColor=LeftColor;
	DPlayer(NewPlayer).ServerColor=ServerColor;

	if (InFace!="")
	{
	InTFace=texture(DynamicLoadObject(InFace,class'Texture'));
	InDFace=Class<DFace>(DynamicLoadObject(InFace,class'Class'));
	if (InTFace!=None)
	DPRI(NewPlayer.PlayerReplicationInfo).FaceTexture=InTFace;
	if (InDFace!=None)
	DPRI(NewPlayer.PlayerReplicationInfo).FaceClass=InDFace;
	}

	if ( InSkin != "" )
		NewPlayer.static.SetMultiSkin(NewPlayer, InSkin, InFace, InTeam);

	if ( !ChangeTeam(newPlayer, InTeam) )
	{
		Error = FailedTeamMessage;
		return None;
	}

	if( NewPlayer.IsA('PlayerPawn') && !(NewPlayer.IsA('DSpectator')) )
		NumPlayers++;

	if( NewPlayer.IsA('DSpectator') && (Level.NetMode == NM_DedicatedServer) )
		NumSpectators++;
	if( NewPlayer.IsA('DSpectator') )
		DPRI(DPlayer(NewPlayer).PlayerReplicationInfo).bSpec=True;

	// Init player's information.
	NewPlayer.ClientSetRotation(NewPlayer.Rotation);
	if( InName=="" )
		InName=DefaultPlayerName;

	//if ((InName!="")&&(InName!=DefaultPlayerName))
	//if( Level.NetMode!=NM_Standalone || NewPlayer.PlayerReplicationInfo.PlayerName==DefaultPlayerName )
		//ChangeName( NewPlayer, InName, false );
	if (True)
		{
		NewPlayer.PlayerReplicationInfo.PlayerName=InName;
		Log("Changed incoming player's name to "$InName,'DCoop');
		}

	// Init player's replication info
	NewPlayer.GameReplicationInfo = GameReplicationInfo;

	// If we are a server, broadcast a welcome message.
	if( Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_ListenServer )
		//BroadcastMessage( NewPlayer.PlayerReplicationInfo.PlayerName$EnteredMessage, false );
		BrMsg(NewPlayer.PlayerReplicationInfo.PlayerName$EnterMsg,'JoinMessage',True);

	// Teleport-in effect.
	StartSpot.PlayTeleportEffect( NewPlayer, true );

	// Set the player's ID.
	NewPlayer.PlayerReplicationInfo.PlayerID = CurrentID++;

	// Log it.
	if ( LocalLog != None )
		LocalLog.LogPlayerConnect(NewPlayer);
	if ( WorldLog != None )
		WorldLog.LogPlayerConnect(NewPlayer);

	if ( (NewPlayer != none) && (!NewPlayer.IsA('DSpectator')) )
	{
		NewPlayer.bHidden = false;
		NewPlayer.SetCollision(true,true,true);
	}

	if (NewPlayer.IsA('DPlayer'))
	DPlayer(NewPlayer).MyIp=IPAddr;

	return NewPlayer;
}

/* PostLogin: Init Player's ID */
event PostLogin( playerpawn NewPlayer )
{
	local string IPAddr;
	IPAddr=NHandler.GetIP(2,NewPlayer);
	if (NewPlayer.IsA('DPlayer'))
	if (DPlayer(NewPlayer).MyIp=="")
	DPlayer(NewPlayer).MyIp=IPAddr;
	// Start player's music.
	NewPlayer.ClientSetMusic( Level.Song, Level.SongSection, Level.CdTrack, MTRAN_Fade );
	if (Level.Song!=None)
	if (NewPlayer.PlayerReplicationInfo!=none)
	if (NewPlayer.PlayerReplicationInfo.IsA('DPRI'))
	{
	DPRI(NewPlayer.PlayerReplicationInfo).SongName=Left(String(Level.Song),InStr(String(Level.Song),"."));
	DPRI(NewPlayer.PlayerReplicationInfo).SongSect=Level.SongSection;
	}
	//if (NewPlayer.IsA('DPlayer')) DPlayer(NewPlayer).ClientReplicateConsole();
	if (NewPlayer.IsA('DPlayer'))
	{
	DPlayer(NewPlayer).ReCalcId();
	DPlayer(NewPlayer).ClientSendDPass();
	}
	CGHandler.HandlePostLogin(NewPlayer);
	if (NewPlayer.IsA('DPlayer'))
	{
	DPlayer(NewPlayer).SSMFade=SSMFade;
	DPlayer(NewPlayer).MOTDFadeOut=MOTDFadeOut;
	DPlayer(NewPlayer).MsgLife=MsgLife;
	DPlayer(NewPlayer).EnteredColor=EnteredColor;
	DPlayer(NewPlayer).LeftColor=LeftColor;
	DPlayer(NewPlayer).ServerColor=ServerColor;
	}
}

/* Logout: Do teh stuff */
function Logout( pawn Exiting )
{
	if ( Exiting.IsA('PlayerPawn') && (!Exiting.IsA('DSpectator')) )
	{
		if (Exiting.PlayerReplicationInfo==None)
		NumPlayers--;
		else
		if (Exiting.PlayerReplicationInfo.IsA('DPRI'))
		if (!DPRI(Exiting.PlayerReplicationInfo).bInvisible)
		NumPlayers--;
	}
	if ( Exiting.IsA('DSpectator') )
		NumSpectators--;
	else if( Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_ListenServer )
//		BroadcastMessage( Exiting.PlayerReplicationInfo.PlayerName$LeftMessage, false );
	{
		if (!Exiting.IsA('DPlayer'))
		BrMsg(Exiting.PlayerReplicationInfo.PlayerName$LeaveMsg,'LeaveMessage',True);
		else
		{
		if (DPlayer(Exiting).bKicked)
		BrMsg(Exiting.PlayerReplicationInfo.PlayerName$KickMsg,'LeaveMessage',True);
		else
		BrMsg(Exiting.PlayerReplicationInfo.PlayerName$LeaveMsg,'LeaveMessage',True);
		}
	}

	CGHandler.HandleLogout(Exiting);

	if ( LocalLog != None )
		LocalLog.LogPlayerDisconnect(Exiting);
	if ( WorldLog != None )
		WorldLog.LogPlayerDisconnect(Exiting);
}

function CheckPlayerID(DPlayer PP)
{
	local int I;
    	for (I=0;I<255;I++)
			if (Banned[I].bRealBan)
		    	if (Banned[I].bIDBan)
		    		if (MaskedCompare(PP.MyId,Banned[I].BanID,false))
		    		{
		    			if (Banned[I].bTemp)
		    				{
		    				//Error="Your are temporarily banned ("$Banned[I].LeftMC$" MC) from this server!";
		    				Log(PP.PlayerReplicationInfo.PlayerName$" failed CheckPlayerID because of a TBan ("$Banned[I].LeftMC$" MC).",'DCoop');
		    				//BrXMsg(Level,InName$"|"$"Temporary IP ban",None,None,None,0,class'DFailJoinMsg');
							BrMsg(PP.PlayerReplicationInfo.PlayerName$" failed CheckPlayer (Temporary ban)",'FailJoinMessage',True);
							PP.RecvMsg(DCPri,"You are temporarily banned ("$Banned[I].LeftMC$" MC) from this server!",'Error',True);
							PP.Destroy();
		    				}
		    			else
		    				{
		    				//Error="You are permanently banned from this server!";
		    				Log(PP.PlayerReplicationInfo.PlayerName$" failed CheckPlayerID because of a PBan.",'DCoop');
		    				//BrXMsg(Level,InName$"|"$"Permanent IP ban",None,None,None,0,class'DFailJoinMsg');
							BrMsg(PP.PlayerReplicationInfo.PlayerName$" failed CheckPlayer (Permanent ban)",'FailJoinMessage',True);
	   						PP.RecvMsg(DCPri,"You are permanently banned from this server!",'Error',True);
	   						PP.Destroy();
		    				}
		    		}
}

function ProcessServerTravel( string URL, bool bItems )
{
	local playerpawn P;
	local DHandler DH;

	bItems=True;

	foreach AllActors(Class'DHandler',DH)
		DH.NotifyEndGame(False);

	if (LocalLog != None)
	{
		LocalLog.LogGameEnd("mapchange");
		LocalLog.StopLog();
		LocalLog.Destroy();
		LocalLog = None;
	}

	if (WorldLog != None)
	{
		WorldLog.LogGameEnd("mapchange");
		WorldLog.StopLog();
		WorldLog.Destroy();
		WorldLog = None;
	}

	// Notify clients we're switching level and give them time to receive.
	// We call PreClientTravel directly on any local PlayerPawns (ie listen server)
	log("ProcessServerTravel:"@URL);
	foreach AllActors( class'PlayerPawn', P )
		if( NetConnection(P.Player)!=None )
			P.ClientTravel( URL, TRAVEL_Relative, bItems );
		else
			P.PreClientTravel();

	// Switch immediately if not networking.
	if( Level.NetMode!=NM_DedicatedServer && Level.NetMode!=NM_ListenServer )
		Level.NextSwitchCountdown = 0.0;
}

function ChangeName( Pawn Other, coerce string S, bool bNameChange )
{
	if( S == "" || S == Other.PlayerReplicationInfo.PlayerName )
		return;
	if( bNameChange )
		BrMsg(Other.PlayerReplicationInfo.PlayerName$RenameMsg$S,'ServerEvent',True);
	Other.PlayerReplicationInfo.PlayerName = S;
}

function ULogin(DPlayer PP, string Params)
{UHandler.HandleLogin(PP,Params);}

function ULogout(DPlayer PP)
{UHandler.HandleLogout(PP);}

function SendPlayer( PlayerPawn aPlayer, string URL )
{
	local DPRI PRI;
	local int V,N;
	local int Pct;
	if (IsInState('PreEnding')) return;
	if (IsInState('Ending')) return;
	if (!aPlayer.IsA('DPlayer')) return;
	if (!aPlayer.PlayerReplicationInfo.IsA('DPri')) return;
	if (bDontEnd)
	{
	aPlayer.ClientMessage("End is currently disabled.",'ServerEvent',True);
	return;
	}
	if (bAllowVoteEnd)
	{
	if (!DPRI(aPlayer.PlayerReplicationInfo).bVoteEnd)
		UpdateVoteEnd(DPlayer(aPlayer));
	V=0;
	foreach AllActors(Class'DPRI',PRI)
		if (!PRI.bSpec)
		{
		N++;
		if (PRI.bVoteend)
			V++;
		}
	Pct=int(100*(float(V)/float(N)));
	if (Pct<int(100*VoteEndPct))
		{
		aPlayer.ClientMessage("Not enough players voted in order to end, "$Pct$"% voted, "$(100*VoteEndPct)$"% required.",'ServerEvent',True);
		return;
		}
	}
	EndingGuy=aPlayer;
	EndingURL=URL;
	GotoState('PreEnding');
}

function string Cap(string S)
{
if (S=="") return ""; else return Caps(Left(S,1))$Mid(S,1);
}

function string FixM(string S)
{
return S;
//if (Left(S,1)==" ") S=Mid(S,1);
//return ReplaceStr(ReplaceStr(S,"  an "," an "),"  a "," a ");
}

function CBroadcastMessage(coerce string Msg, optional bool bBeep, optional name Type)
{BroadcastMessage(Cap(FixM(Msg)),bBeep,Type);}

function bool AllowsBroadcast( actor broadcaster, int Len )
{
	return (Len < 1024); /* Fuck you */
}


function Killed(pawn killer, pawn Other, name damageType)
{
	local string killed;
	local string message;
	local string KillerWeaponName;
	local string VictimWeaponName;
	local string DeathMessage;
//	local string NA1, NA2;
	if (Other.bIsPlayer || bShowAllDeaths)
	{
	KHandler.DmgType=DamageType;
//	if (Killer!=None) {NA1=Killer.NameArticle; if (Left(NA1,1)==" ") Killer.NameArticle=Mid(NA1,1);}
//	if (Other!=None) {NA2=Other.NameArticle; if (Left(NA2,1)==" ") Other.NameArticle=Mid(NA2,1);}
		if ( (Killer == Other) || (Killer == None) )
		{
			// suicide
			if (damageType=='LowBound')
				BrMsg(Other.GetHumanName()$" fell off low boundary of the world.", 'DeathMessage', false);
			else if (damageType=='HiBound')
				BrMsg(Other.GetHumanName()$" flew off high boundary of the world.", 'DeathMessage', false);
			else
			{
			if ( LocalLog != None ) LocalLog.LogSuicide(Other, damageType);
			if ( WorldLog != None ) WorldLog.LogSuicide(Other, damageType);
			if (!bKaosDmStyle || bParseTHIS)
			{
			message = KillMessage(damageType, Other);
			BrMsg(Other.GetHumanName()$message, 'DeathMessage', false);
			}
			else
			{
			if (DamageType!='crushed')
			message = KHandler.KaosSuicideMsg(Other.GetHumanName());
			else
			message = KHandler.KaosDeathMsg("a Mover",Other.GetHumanName(),"","");
			BrMsg(message, 'DeathMessage', false);
			}
			}
		}
		else
		{
			if (Killer.Weapon != None)
			{
				KillerWeaponName = Killer.Weapon.ItemName;
				DeathMessage = Killer.Weapon.DeathMessage;
			}
			if (Other.Weapon != None)
				VictimWeaponName = Other.Weapon.ItemName;

			if (Killer.bIsPlayer)
			if (Other.bIsPlayer)
			{
			if ( LocalLog != None )	LocalLog.LogKill(Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID, KillerWeaponName, VictimWeaponName, damageType);
			if ( WorldLog != None )	WorldLog.LogKill(Killer.PlayerReplicationInfo.PlayerID, Other.PlayerReplicationInfo.PlayerID, KillerWeaponName, VictimWeaponName, damageType);
			}

			killed = Other.GetHumanName();
			if ( (DamageType == 'SpecialDamage') && (SpecialDamageString != "") )
			{
				message = ParseKillMessage(Killer.GetHumanName(), Other.GetHumanName(), KillerWeaponName, SpecialDamageString);
				BrMsg(message, 'DeathMessage', false);
			}
/*			else if ( bClassicDeathmessages || (Killer.Weapon == None) || ((DamageType != Killer.Weapon.MyDamageType) && (DamageType != Killer.Weapon.AltDamageType)) )
			{
				message = killer.KillMessage(damageType, Other);
				BrMsg(killed$message, 'DeathMessage', false);
			}			*/
			else
			{
				message = ParseKillMessage(Killer.GetHumanName(), Other.GetHumanName(), KillerWeaponName, DeathMessage);
				BrMsg(message, 'DeathMessage', false);
			}
		}
//	if (Killer!=None) Killer.NameArticle=NA1;
//	if (Other!=None) Other.NameArticle=NA2;
	}
	ScoreKill(killer, Other);
}

function string ParseKillMessage( string KillerName, string VictimName, string WeaponName, string DeathMessage )
{
	if (bKaosDmStyle && !bParseThis)
		return KaosDeathMsg(KillerName,VictimName,WeaponName,DeathMessage);
	else
		return super.ParseKillMessage(KillerName,VictimName,WeaponName,DeathMessage);
}

function string KaosDeathMsg( string KillerName, string VictimName, string WeaponName, string DeathMessage )
{
	return KHandler.KaosDeathMsg(KillerName,VictimName,WeaponName,DeathMessage);
}

function string TTS(string S)
{
if (S=="") return "";
if (Left(S,1)==" ") return Mid(S,1);
return S;
}

function ScoreKill(pawn Killer, pawn Other)
{
	if (Other!=None)
	{
	Other.DieCount++;
	if (Other.IsA('DPlayer'))
		{
		DPRI(Other.PlayerReplicationInfo).Deaths+=1;
		if (DPRI(Other.PlayerReplicationInfo).KSpree>10)
		{
		if ((Killer!=None)&&(Killer!=Other))
		BrMsg(Other.PlayerReplicationInfo.PlayerName$"'s killing spree was ended by "$TTS(Killer.GetHumanName()),'KillingSpree',True);
		else
		BrMsg(Other.PlayerReplicationInfo.PlayerName$"'s killing spree was ended by "$DPlayer(Other).HisHer()$" own dumb self.",'KillingSpree',True);
		}
		DPRI(Other.PlayerReplicationInfo).KSpree=0;
		}
	if( (killer == Other) || (killer == None) )
		{
		Other.PlayerReplicationInfo.Score += SuicidePenalty;
		if (Other.PlayerReplicationInfo.IsA('DPRI'))
		DPRI(Other.PlayerReplicationInfo).DScore += SuicidePenalty;
		}
	else if ( killer != None )
	{
		killer.killCount++;
		if ( killer.PlayerReplicationInfo != None )
			{
			killer.PlayerReplicationInfo.Score += 1;
			if (Killer.PlayerReplicationInfo.IsA('DPRI'))
			DPRI(Killer.PlayerReplicationInfo).DScore += 1;
			}
	}
	if ( killer!=None )
	{
	if ( killer.bIsPlayer )
	if ( killer.PlayerReplicationInfo!=None )
	if ( (Killer != None) && (Other.bIsPlayer) && (Other!=Killer) )
		{
		killer.PlayerReplicationInfo.Score += (FFKillPenalty - 1);
		if (Killer.PlayerReplicationInfo.IsA('DPRI'))
		DPRI(Killer.PlayerReplicationInfo).DScore += (FFKillPenalty - 1);
		}
	if (Killer.IsA('DPlayer'))
	if (Killer!=Other)
		{
		DPRI(Killer.PlayerReplicationInfo).KSpree+=1;
		DPRI(Killer.PlayerReplicationInfo).ScoredKill();
		}
	}
	}
}

function bool ShouldRespawn(Actor Other)
{
	if ( Other.IsA('Inventory') && !Inventory(Other).bHeldItem && (Inventory(Other).ReSpawnTime != 0) )
	{
		Inventory(Other).ReSpawnTime = InventoryRespawnTime;
		return true;
	}
	return false;
}

function int IMin(int A, int B)
{
if (A<B) return A; else return B;
}

function int IMax(int A, int B)
{
if (A>B) return A; else return B;
}

function int ActualDamage( int Damage, name DamageType, pawn P )
{
	local int D;
	local inventory I;

	/* Hey thats CHEATING */
	if (P.Health<0) return 0;

	/* Thats cheating too ... blocked */
	D=IMin(Damage,P.Health);

	/* Like attacking sliths with bioges to build up dmgpts blocked */
	if (P.ReducedDamageType==DamageType)
	D=int(float(D)*(1-P.ReducedDamagePct));

	/* Artifical way to calculate damage reduction >_< */
	for (I=P.Inventory;I!=None;I=I.Inventory)
	{
	if (DamageType!='')
	{
	if (I.ProtectionType1==DamageType) return 0; //!! for conviency.
	if (I.ProtectionType2==DamageType) return 0; //!! and speed gain.
	}
	if (I.bIsAnArmor)
	D=IMin(int(float(D)*(1-(float(I.ArmorAbsorption)/100))),I.Charge);
	}

	return D;
}

function int ReduceDamage( int Damage, name DamageType, pawn injured, pawn instigatedBy )
{
//	if ( bNoFriendlyFire && (instigatedBy != None) && instigatedBy.bIsPlayer && injured.bIsPlayer && (instigatedBy != injured) )
//		return 0;
//  NO SHIT!

	if ( (DamageType == 'Fell') && bSpecialFallDamage )
		Damage = Min(Damage, 5);

	if( injured.Region.Zone.bNeutralZone )
		return 0;

	if (SHandler.bUseDamagePoints)
	if (injured!=None)
	if (!injured.bIsPlayer)
	if (instigatedBy!=None)
	if (instigatedBy.IsA('DPlayer'))
	DPlayer(instigatedBy).myPRI.DmgPts+=ActualDamage(Damage,DamageType,injured);

	return Damage;
}

function string GetLStr(int Lev)
{
	return UHandler.GetLStr(Lev);
}

function bool CanSpectate( pawn Viewer, actor ViewTarget )
{
//	if (ViewTarget.Location==vect(0,0,0)) return false; /* Why the heck? */
	return true;
}

function string ProcClass(string S)
{
if (InStr(S,".")==-1) return "UnrealI."$S;
return S;
}

function RebuildGiveItems()
{
	local int I;
	for (I=0;I<128;I++)
	if (GiveItems[I]!="")
		GiveItem[I]=Class<Inventory>(DynamicLoadObject(ProcClass(GiveItems[I]),class'Class'));
}

function AddDefaultInventory( pawn PlayerPawn )
{
	local Translator newTranslator;
	local Weapon newWeapon;
	local class<Weapon> DefaultWeaponC;
	local string DWC;

	if( PlayerPawn.IsA('DSpectator') )
		return;

	DWC=ProcClass(DefaultWeaponClass);
	DefaultWeaponC=class<Weapon>(DynamicLoadObject(DWC,class'Class'));

	// Spawn default weapon.
	if( DefaultWeaponC!=None && PlayerPawn.FindInventoryType(DefaultWeaponC)==None )
	{
	newWeapon = Spawn(DefaultWeaponC);
	if( newWeapon != None )
	{
		newWeapon.Instigator = PlayerPawn;
		newWeapon.BecomeItem();
		PlayerPawn.AddInventory(newWeapon);
		newWeapon.BringUp();
		newWeapon.GiveAmmo(PlayerPawn);
		newWeapon.SetSwitchPriority(PlayerPawn);
		newWeapon.WeaponSet(PlayerPawn);
	}
	}

	// Spawn translator.
	if( PlayerPawn.FindInventoryType(class'Translator') == None )
	{
	newTranslator = Spawn(class'Translator',,, Location);
	if( newTranslator != None )
	{
		newTranslator.bHeldItem = true;
		newTranslator.GiveTo( PlayerPawn );
		PlayerPawn.SelectedItem = newTranslator;
		newTranslator.PickupFunction(PlayerPawn);
	}
	}

	RebuildGiveItems(); //Just in case

	GiveItemsTo(PlayerPawn);
}

function GiveItemsTo( Pawn PP )
{
	local inventory Inv;
	local int I;
	local bool bCWP, bCW;

	if (PP.IsA('DPlayer'))
	DPlayer(PP).bDontRecvPickup=True;
	For(I=0;I<128;I++)
	if (GiveItem[I]!=None)
	{
		bCWP=GiveItem[i].Default.bCollideWhenPlacing;
		bCW=GiveItem[i].default.bCollideWorld;

		GiveItem[i].Default.bCollideWhenPlacing = False;
		GiveItem[i].Default.bcollideWorld = False;

		Inv = Spawn( GiveItem[i],PP,'',PP.Location,PP.Rotation );

		GiveItem[i].Default.bCollideWhenPlacing = bCWP;
		GiveItem[i].Default.bcollideWorld = bCW;

		if( Inv==None )
			Continue;
			/* Mind if it havent been spawned / rejected by SP checker? */

		Inv.SetCollision(False,False,False);
		Inv.Pickupmessage="";
		Inv.Pickupsound=None;
		Inv.bHeldItem=True;
		Inv.Touch(PP);
		Inv.PickupMessage=Inv.Default.Pickupmessage;
		Inv.PickupSound=Inv.Default.Pickupsound;

		If( Inv.GetStateName() == 'Sleeping' || Inv.GetStateName() == 'Pickup' || Inv.GetStateName()==Inv.InitialState )
			Inv.Destroy();
	}
	if (PP.IsA('DPlayer'))
	DPlayer(PP).bDontRecvPickup=False;
}

function BuyItemSc(DPlayer PP, int I)
{
	SHandler.BuyItemSc(PP,I);
}

function BuyItemDp(DPlayer PP, int I)
{
	SHandler.BuyItemDp(PP,I);
}

function DiscardInventory( Pawn Other )
{
	local actor dropped;
	local inventory Inv;
	local weapon weap;
	local float speed;

	if ( Other.IsA('DPlayer') )
	if ( bKeepInventory )
	return;

	if( Other.DropWhenKilled != None )
	{
		dropped = Spawn(Other.DropWhenKilled,,,Other.Location);
		Inv = Inventory(dropped);
		if ( Inv != None )
		{
			Inv.RespawnTime = 0.0; //don't respawn
			Inv.BecomePickup();
		}
		if ( dropped != None )
		{
			dropped.RemoteRole = ROLE_DumbProxy;
			dropped.SetPhysics(PHYS_Falling);
			dropped.bCollideWorld = true;
			dropped.Velocity = Other.Velocity + VRand() * 280;
		}
		if ( Inv != None )
			Inv.GotoState('PickUp', 'Dropped');
	}
	if( (Other.Weapon!=None) && (Other.Weapon.Class!=DefaultWeapon)
		&& Other.Weapon.bCanThrow )
	{
		speed = VSize(Other.Velocity);
		weap = Other.Weapon;
		weap.Velocity = Normal(Other.Velocity/speed + 0.5 * VRand()) * (speed + 280);
		Other.TossWeapon();
		if ( weap.PickupAmmoCount == 0 )
			weap.PickupAmmoCount = 1;
	}
	Other.Weapon = None;
	Other.SelectedItem = None;
	for( Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory )
		{
		if (bMonstersDropAllInv)
		Inv.DropFrom(Other.Location + vect(0,0,1) * Other.EyeHeight);
		else
		Inv.Destroy();
		}
}

function bool RestartPlayer( pawn aPlayer )
{
	local NavigationPoint startSpot;
	local bool foundStart;

	if( bRestartLevel && Level.NetMode!=NM_DedicatedServer && Level.NetMode!=NM_ListenServer )
		return true;

	startSpot = DCFindPlayerStart(aPlayer);
	if( startSpot == None )
		return false;

	foundStart = aPlayer.SetLocation(startSpot.Location);
	if( foundStart )
	{
		startSpot.PlayTeleportEffect(aPlayer, true);
		aPlayer.SetRotation(startSpot.Rotation);
		aPlayer.ViewRotation = aPlayer.Rotation;
		aPlayer.Acceleration = vect(0,0,0);
		aPlayer.Velocity = vect(0,0,0);
		aPlayer.Health = aPlayer.Default.Health;
		aPlayer.SetCollision( true, true, true );
		aPlayer.ClientSetLocation( startSpot.Location, startSpot.Rotation );
		aPlayer.bHidden = false;
		aPlayer.DamageScaling = aPlayer.Default.DamageScaling;
		aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
		AddDefaultInventory(aPlayer);
	}

	Spawn(class'PawnTeleportEffect',aPlayer,'',startSpot.Location,startSpot.Rotation);
	if (aPlayer.IsA('PlayerPawn'))
		PlayerPawn(aPlayer).SetFOVAngle(170);
	aPlayer.PlaySound(sound'PRespawn',, 255.0);

	return foundStart;
}

function GlobCDSound(int I)
{
switch (I)
{
case 300: GlobSound(sound'Left5Min'); break;
case 180: GlobSound(sound'Left3Min'); break;
case 60: GlobSound(sound'Left1Min'); break;
case 30: GlobSound(sound'Left30Sec'); break;
case 10: GlobSound(sound'Left10Sec'); break;
case 9: GlobSound(sound'Left9Sec'); break;
case 8: GlobSound(sound'Left8Sec'); break;
case 7: GlobSound(sound'Left7Sec'); break;
case 6: GlobSound(sound'Left6Sec'); break;
case 5: GlobSound(sound'Left5Sec'); break;
case 4: GlobSound(sound'Left4Sec'); break;
case 3: GlobSound(sound'Left3Sec'); break;
case 2: GlobSound(sound'Left2Sec'); break;
case 1: GlobSound(sound'Left1Sec'); break;
}
}

auto state Init
{
Begin:
GotoState('InGame');
}

state InGame
{
Begin:

}

state PreEnding
{
Begin:
if (bAllowVoteCancel)
	BrMsg("Say 'no' or type VoteCancel to abort ending",'EndCountDownIM',true);
BrMsg("Level ends in...",'EndCountDownIM',true);
Sleep(1);
for (CDT=10;CDT>0;CDT--)
{
	BrMsg(CDT$"...",'EndCountDown',!bUseCountdownSounds);
	if (bUseCountdownSounds)
		GlobCDSound(CDT);
	Sleep(1);
}
GotoState('Ending');
}

state Ending
{
Begin:
if (bForceNextMap)
	EndingURL=NextMap;
for (IterPawn=Level.PawnList;IterPawn!=None;IterPawn=IterPawn.NextPawn)
	if (IterPawn.IsA('PlayerPawn'))
	{
		if (EndingGuy!=None)
			PlayerPawn(IterPawn).ViewTarget=EndingGuy;
		else
			PlayerPawn(IterPawn).ViewTarget=None;
		PlayerPawn(IterPawn).bBehindView=True;
		IterPawn.GotoState('GameEnded');
		IterPawn.ClientGameEnded();
		PlayerPawn(IterPawn).bFrozen=True;
	}
if (EndingGuy!=None)
{
	BrMsg(EndingGuy.PlayerReplicationInfo.PlayerName$" have ended this level.",'EndCountDownIM',True);
	GlobSound(sound'Winner');
}
else
	GlobSound(sound'LostMatch');
Sleep(5);
//SendPlayer(EndingGuy,EndingURL);
if ((EndingUrl=="")||(bForceNextMap))
//foreach AllActors(class'Teleporter',IterTele)
//if( (InStr( IterTele.URL, "/" ) >= 0) || (InStr( IterTele.URL, "#" ) >= 0) )
//	{ EndingUrl=IterTele.URL; break; }
EndingUrl=NextMap;
bGameEnded=True;
//Level.ServerTravel(EndingUrl,True);
for (IterPawn=Level.PawnList;IterPawn!=None;IterPawn=IterPawn.NextPawn)
	if (IterPawn.IsA('DPlayer'))
		DPlayer(IterPawn).RespectEnded();
if (Left(EndingURL,7)~="EndGame")
{
if (DynamicLoadObject("DEndGame.LevelInfo0",class'LevelInfo')!=None)
EndingUrl="dendgame"; /* OH YEAH! */
else
EndingUrl="vortex2"; /* Fuck you. */
}
if (Left(EndingURL,11)~="ExtremeDGen") EndingUrl="extremedark";
if (bUseCoolURLs)
{
EndingURL=ReplaceStr(EndingUrl,"ass","ASS");
EndingURL=ReplaceStr(EndingUrl,"evil","EVIL");
EndingURL=ReplaceStr(EndingUrl,"bed","BED");
EndingURL=ReplaceStr(EndingUrl,"xtreme","XTREME");
}
Level.ServerTravel(EndingURL,True);
}

function string ReplaceStr(string _S, string _R, string _N)
{
local string _L;
local int _I;
_L=_S;
while( InStr(_L, _R) >= 0 )
{
 _i = InStr(_L, _R);
 _L = Left(_L,_i) $ _N $ Mid(_L,_i+Len(_R));
}
return _L;
}

function string ReplaceStr2(string _S, string _R, string _N)
{
local string _L;
local int _I;
_L=_S;
while( InStr(Caps(_L), Caps(_R)) >= 0 )
{
 _i = InStr(Caps(_L), Caps(_R));
 _L = Left(_L,_i) $ _N $ Mid(_L,_i+Len(_R));
}
return _L;
}

function EndGame( string Reason )
{
	local actor A;
	local int I;

	// don't end game if not really ready
	if ( !SetEndCams(Reason) )
	{
		bOverTime = true;
		return;
	}
	bGameEnded = true;
	foreach AllActors(class'Actor', A, 'EndGame')
		A.trigger(self, none);

	if (LocalLog != None)
	{
		LocalLog.LogGameEnd(Reason);
		LocalLog.StopLog();
		LocalLog.Destroy();
		LocalLog = None;
//		ExecuteLocalLogBatcher();
	}
	if (WorldLog != None)
	{
		WorldLog.LogGameEnd(Reason);
		WorldLog.StopLog();
		WorldLog.Destroy();
		WorldLog = None;
//		ExecuteWorldLogBatcher();
	}
	//Temporary bans: Decrease
	for (I=0;I<255;I++)
	if (Banned[I].bRealBan)
	if (Banned[I].bTemp)
	{
	Banned[I].LeftMC--;
	if (Banned[I].LeftMC==0)
	{
		Log("Temporary ban expired:",'DCoop');
		Log("["$I$"-"$BtS(Banned[I].bEnabled)$BtSt(Banned[I].bTemp,Banned[I].LeftMC)$"]: "$Banned[I].BanID$"-"$Banned[I].BanIP,'DCoop');
		Banned[I].BanID="";
		Banned[I].BanIP="";
		Banned[I].bEnabled=False;
		Banned[I].bIDBan=False;
		Banned[I].bIPBan=False;
		Banned[I].bRealBan=False;
		Banned[I].bTemp=False;
		Banned[I].LeftMC=0;
	}
	}
	SaveConfig();
}

event GameEnding()
{
	local DHandler DH;

	foreach AllActors(Class'DHandler',DH)
		DH.NotifyEndGame(True);

	if (LocalLog != None)
	{
		LocalLog.LogGameEnd("serverquit");
		LocalLog.StopLog();
		LocalLog.Destroy();
		LocalLog = None;
	}

	if (WorldLog != None)
	{
		WorldLog.LogGameEnd("serverquit");
		WorldLog.StopLog();
		WorldLog.Destroy();
		WorldLog = None;
	}

	SaveConfig();
}

function string PlayerKillMessage( name damageType, pawn Other )
{
	local string message;
	local float decision;

	if (bKaosDmStyle)
		return KHandler.PlayerKillMessage(DamageType,Other);

	decision = FRand();

	if ( (Other.Health < - 25) && (decision < 0.3) )
	{
		decision = FRand();
		if ( decision < 0.35 )
			message = MajorDeathMessage[0];
		else if ( decision < 0.7 )
			message = MajorDeathMessage[1];
		else
			message = MajorDeathMessage[2];
	}
	else
	{
		if ( DamageType == 'Decapitated' )
		{
			if ( FRand() < 0.4 )
				message = HeadLossMessage[1];
			else
				message = HeadLossMessage[0];
		}
		else
			message = DeathMessage[Rand(32)];

		decision = Other.Health * FRand();
		if ( decision < -35 )
			message = DeathModifier[4]$message;
		else if ( decision < -30 )
			message = DeathModifier[3]$message;
		else if ( decision < -22 )
			message = DeathModifier[2]$message;
		else if ( decision < -15 )
			message = DeathModifier[1]$message;
		else if ( decision < -8 )
			message = DeathModifier[0]$message;
	}

	return ( DeathVerb$message$DeathPrep );
}

function UpdateVoteKick(DPlayer PP, int I)
{
	local DPRI PRI;
	local int V,N;
	local int Pct;
	local DPlayer P;
	if (!bAllowVoteKick)
	{ PP.RecvMsg(DCPri,"VoteKick is disabled.",'Error',False); return;}
	if (I==0)
	{
	if (PP.myPRI.iVoteKick==0)
	{ PP.RecvMsg(DCPri,"You have not kickvoted, so cant take it away.",'Error',False); return;}
	else
	{ PP.myPRI.iVoteKick=0; BrMsg(PP.myPRI.PlayerName$" have revoked "$PP.HisHer()$" kickvote.",'ServerEvent',True); return; }
	}
	P=GetPP(I);
	if (P==None)
	{ PP.RecvMsg(DCPri,"That player does not exist.",'Error',False); return; }
	PP.myPRI.iVoteKick=I;
	V=0;
	foreach AllActors(Class'DPRI',PRI)
		if (!PRI.bSpec)
		{
		N++;
		if (PRI.iVoteKick==I)
			V++;
		}
	Pct=int(100*(float(V)/float(N)));
	BrMsg(PP.myPRI.PlayerName$" have placed a kick vote against "$P.myPRI.PlayerName$": "$Pct$"% voted, "$int(100*VoteKickPct)$"% required for kick.",'ServerEvent',True);
	if (Pct>=int(100*VoteKickPct))
		KickVoted(P);
}

function KickVoted(DPlayer PP)
{
	local DPRI PRI;
	PP.bKicked=True;
	foreach AllActors(Class'DPRI',PRI)
		if (PRI.iVoteKick==PP.myPRI.PlayerID)
			PRI.iVoteKick=0;
	PP.Destroy();
}

function UpdateVoteEnd(DPlayer PP)
{
	local DPRI PRI;
	local int V,N;
	local int Pct;
	if (!bAllowVoteEnd)
	{ PP.RecvMsg(DCPri,"VoteEnd is disabled.",'Error',False); return;}
	PP.myPRI.bVoteEnd=!PP.myPRI.bVoteEnd;
	V=0;
	foreach AllActors(Class'DPRI',PRI)
		if (!PRI.bSpec)
		{
		N++;
		if (PRI.bVoteEnd)
			V++;
		}
	Pct=int(100*(float(V)/float(N)));
	if (PP.myPRI.bVoteEnd)
	BrMsg(PP.myPRI.PlayerName$" voted for ending this map. "$Pct$"% voted, "$int(100*VoteEndPct)$"% required for end.",'ServerEvent',True);
	else
	BrMsg(PP.myPRI.PlayerName$" revoked "$PP.HisHer()$" vote for ending this map. "$Pct$"% voted, "$int(100*VoteEndPct)$"% required for end.",'ServerEvent',True);
}

function UpdateVoteSkip(DPlayer PP)
{
	local DPRI PRI;
	local int V,N;
	local int Pct;
	if (!bAllowVoteSkip)
	{ PP.RecvMsg(DCPri,"VoteSkip is disabled.",'Error',False); return;}
	PP.myPRI.bVoteSkip=!PP.myPRI.bVoteSkip;
	V=0;
	foreach AllActors(Class'DPRI',PRI)
		if (!PRI.bSpec)
		{
		N++;
		if (PRI.bVoteSkip)
			V++;
		}
	Pct=int(100*(float(V)/float(N)));
	if (PP.myPRI.bVoteSkip)
	BrMsg(PP.myPRI.PlayerName$" voted for skipping this map. "$Pct$"% voted, "$int(100*VoteSkipPct)$"% required for skip.",'ServerEvent',True);
	else
	BrMsg(PP.myPRI.PlayerName$" revoked "$PP.HisHer()$" vote for skipping this map. "$Pct$"% voted, "$int(100*VoteSkipPct)$"% required for skip.",'ServerEvent',True);
	if (Pct>=int(100*VoteSkipPct))
		SkipThisMap();
}

function SkipThisMap()
{
	BrMsg("The level have been skipped.",'EndCountdownIM',True);
	EndingGuy=None;
	EndingURL="";
	GotoState('Ending');
}

function UpdateVoteCancel(DPlayer PP)
{
	local DPRI PRI;
	local int V,N;
	local int Pct;
	if (!bAllowVoteCancel)
	{ PP.RecvMsg(DCPri,"VoteCancel is disabled.",'Error',False); return;}
	if (IsInState('Ending'))
	{ PP.RecvMsg(DCPri,"Too late :P. Game already ended.",'Error',False); return;}
	if (!IsInState('PreEnding'))
	{ PP.RecvMsg(DCPri,"Game is not ending yet.",'Error',False); return;}
	if (PP.myPRI.bVoteCancel)
	{ PP.RecvMsg(DCPri,"You have already voted for cancelling end countdown.",'Error',False); return;}
	PP.myPRI.bVoteCancel=True;
	V=0;
	foreach AllActors(Class'DPRI',PRI)
		if (!PRI.bSpec)
		{
		N++;
		if (PRI.bVoteCancel)
			V++;
		}
	Pct=int(100*(float(V)/float(N)));
	BrMsg(PP.myPRI.PlayerName$" voted for cancelling end countdown: "$Pct$"% voted, "$int(100*VoteCancelPct)$"% required for cancel.",'ServerEvent',True);
	if (Pct>=int(100*VoteCancelPct))
		CancelEndCountdown();
}

function CancelEndCountdown()
{
	local DPRI PRI;
	foreach AllActors(Class'DPRI',PRI)
		PRI.bVoteCancel=False;
	GotoState('InGame');
	EndingGuy=None; EndingUrl="";
	BrMsg("End countdown cancelled!",'EndCountdownIM',True);
}

function UpdateVoteMap(DPlayer PP, int I)
{
	local DPRI PRI;
	local int V,N;
	local int Pct;
	if (!bAllowVoteMap)
	{ PP.RecvMsg(DCPri,"VoteMap is disabled.",'Error',False); return;}
	if (I<0) { PP.RecvMsg(DCPri,"Out of range.",'Error',False); return; }
	if (I>127) { PP.RecvMsg(DCPri,"Out of range.",'Error',False); return; }
	if (I==0)
	{
	BrMsg(PP.myPRI.PlayerName$" revoked "$PP.HisHer()$" MapVote.");
	PP.myPRI.iVoteMap=I;
	}
	if (VoteMaps[I]=="")
	{ PP.RecvMsg(DCPri,"Invalid pick, use MapList for list.",'Error',False); return; }
	V=0; N=0;
	foreach AllActors(Class'DPRI',PRI)
		if (!PRI.bSpec)
		{
		N++;
		if (PRI.iVoteMap==I)
			V++;
		}
	Pct=int(100*(float(V)/float(N)));
	BrMsg(PP.myPRI.PlayerName$" voted for "$VoteMaps[I]$": "$Pct$"% voted, "$int(100*VoteMapPct)$"% required.",'ServerEvent',True);
	PP.myPRI.iVoteMap=I;
}

function SendVoteMapList(DPlayer PP)
{
	local int I;
	if (!bAllowVoteMap)
	{ PP.RecvMsg(DCPri,"VoteMap is disabled.",'Error',False); return;}
	for (I=1;I<128;I++)
	if (VoteMaps[I]!="")
	PP.RecvMsg(DCPri,"["$I$"]: "$VoteMaps[I],'Console',False);
	PP.RecvMsg(DCPri,"MapList printed to console",'CriticalEvent',True);
}

function DPRI GetPri(int Id)
{
	local pawn P;
	if (Id==0) return DCPri;
	for (P=Level.PawnList;P!=None;P=P.NextPawn)
	if (P.IsA('DPlayer'))
	if (DPlayer(P).myPRI!=none)
	if (DPlayer(P).myPRI.PlayerID==Id)
	return DPlayer(P).myPRI;
	return none;
}

function DPlayer GetPP(int Id)
{
	local pawn P;
	for (P=Level.PawnList;P!=None;P=P.NextPawn)
	if (P.IsA('DPlayer'))
	if (DPlayer(P).myPRI!=none)
	if (DPlayer(P).myPRI.PlayerID==Id)
	return DPlayer(P);
	return none;
}

function string BtS(bool B)
{
	if (B) return "+"; else return "-";
}

function string BtSt(bool B, int I)
{
	if (!B) return "";
	return ">"$I;
}

function EnBan(int I)
{
	Banned[I].bEnabled=True;
}

function DisBan(int I)
{
	Banned[I].bEnabled=False;
}

function string BData(int I)
{
	return "["$I$"-"$BtS(Banned[I].bEnabled)$BtSt(Banned[I].bTemp,Banned[I].LeftMC)$"]: "$Banned[I].BanID$"-"$Banned[I].BanIP;
}

function bool RB(int I)
{
	return Banned[I].bRealBan;
}

function AddBan(DPlayer PP, optional int TempTime, optional int I)
{
	Banned[I].BanID=PP.MyId;
	Banned[I].BanIP=PP.MyIp;
	Banned[I].bEnabled=True;
	Banned[I].bIDBan=True;
	Banned[I].bIPBan=True;
	Banned[I].bRealBan=True;
	Banned[I].bTemp=(TempTime>0);
	Banned[I].LeftMC=TempTime;
}

function DelBan(int I)
{
	Banned[I].BanID="";
	Banned[I].BanIP="";
	Banned[I].bEnabled=False;
	Banned[I].bIDBan=False;
	Banned[I].bIPBan=False;
	Banned[I].bRealBan=False;
	Banned[I].bTemp=False;
	Banned[I].LeftMC=0;
}

defaultproperties
{
				FFDamageMultiplier=1.000000
				FFMomentumMultiplier=1.000000
				FFReport=True
				InventoryRespawnTime=1.000000
				bKeepInventory=True
				bAllowSprees=True
				bUseSpreeSounds=True
				bAllowMultikills=True
				MultiKillDelay=8.000000
				bUseMultikillSounds=True
				TimeLimit=60.000000
				bUseCountdownSounds=True
				bUseCoolURLs=True
				bShowEnds=True
				bShowAllDeaths=True
				bKaosDmStyle=True
				LowKillZ=-1000000000.000000
				HiKillZ=1000000000.000000
				bAllowModMyPw=True
				MOTDFadeOut=5.000000
				MsgLife=4.000000
				SSMFade=True
				EnteredColor=(R=255,G=255,B=128)
				LeftColor=(R=255,G=128,B=128)
				ServerColor=(R=255,G=255,B=64)
				bUseStaticTex=True
				ConnectMsg=" is connecting to this server..."
				EnterMsg=" entered the game."
				RenameMsg=" have changed name to "
				LeaveMsg=" left the game."
				KickMsg=" have been kicked."
				AHandlerClass="DAHandler"
				CGHandlerClass="DCGHandler"
				NHandlerClass="Automatic"
				RHandlerClass="DRHandler"
				SHandlerClass="DSHandler"
				THandlerClass="DTHandler"
				UHandlerClass="DUHandler"
				FFKillPenalty=-5
				SuicidePenalty=-5
				bUseHardcodedClassOverrides=True
				MinSeeLvl=1
				MinSeeUser=2
				MinSeeAdminMsgs=1
				DefaultWeaponClass="UnrealShare.DispersionPistol"
				NumMultiJumps=4
				bAllowDuckjumps=True
				CSWhenJoined="DCoopSounds.Jingle"
				bTrustConsoleIfCanLoadClass=True
				bTrustStandartUPkgs=True
				MinUntrustedPackagesForKick=999
				bAllowVoteCancel=True
				VoteCancelPct=0.320000
				bAllowVoteEnd=True
				VoteEndPct=0.500000
				bAllowVoteKick=True
				VoteKickPct=0.640000
				VoteMaps(0)="Next Map"
				VoteMapPct=0.500000
				bAllowVoteSkip=True
				VoteSkipPct=0.640000
				DefaultPlayerClass=Class'JSC.DMaleThree'
				CurrentID=1
				ScoreBoardType=Class'JSC.DScoreBoard'
				HUDType=Class'JSC.DHUD'
				GameReplicationInfoClass=Class'JSC.DGRI'
}
